/*
 * *************************************************************************
 *
 * Trimble Navigation, Ltd.
 * OEM Products Development Group
 * P.O. Box 3642
 * 645 North Mary Avenue
 * Sunnyvale, California 94088-3642
 *
 * Corporate Headquarter:
 *    Telephone:  (408) 481-8000
 *    Fax:        (408) 481-6005
 *
 * Technical Support Center:
 *    Telephone:  (800) 767-4822	(U.S. and Canada)
 *                (408) 481-6940    (outside U.S. and Canada)
 *    Fax:        (408) 481-6020
 *    BBS:        (408) 481-7800
 *    e-mail:     trimble_support@trimble.com
 *
 * *************************************************************************
 *
 * This source code is supplied without warranty and is intended as sample
 * source code for exercising the TSIP interface.  We do appreciate comments
 * and try to support the software as much as possible.
 *
 * *************************************************************************
 *
 */

#define TSIPCHAT_VERNUM "1.62"

#define DIAG_MENU    -3
#define REPEAT_MENU  -2
#define ALL_MENU     -1
#define x8E_MENU     0x8E

#define BANNER_TEXT	WHITE
#define BANNER_BACKGROUND	BLUE

#define TSIP	0x02
#define NMEA	0x04

/* data base for keyboard command help screen */
typedef struct {
	int kbch;              /* ASCII code for keystroke */
	unsigned short cmdcode;       /* TSIP command code */
	unsigned short replycode;       /* TSIP command code */
	char cmdtext[18];       /* description of TSIP command */
   void (*cmdfn)(TSIPPKT *cmdptr);
} KB_CMD;

#define MENUWIN 		2
#define CMDWIN       1
#define AUTOWIN      0

#define TSIPFILE     1
#define AUTOFILE     2

#define reply_code(rpt) (((rpt)->code==0x8F)?(*(rpt)->buf+0x100):((rpt)->code))

/**/
/************************** TSIPCHAT.C **********************************/
/* called from main() in TSIPCHAT.C and TSIP_UTL.C */
int ProcessInputBytesWhileWaitingForKBHit
	(void);
/* in TSIP_CMD.C */
void ProcessTSIPKeystroke
	(TSIPPKT *cmd,
	int kbch,
	int *reply);
int DisplayMenuChoices
	(int code,
	KB_CMD *kb_cmd);
/* in TSIP_RPT.C */
void TranslateTSIPReportToText
   (TSIPPKT *rpt, char *obuf);
int print_msg_table_header
	(int rptcode, char *HdrStr, int force);
/************************** TSIP_ALM.C **********************************/
int almgetb
	(void);
int almputb
	(void);
/************************** TSIP_UTL.C **********************************/
/* Utility functions for console display */
int cmd_esc
	(void);
void set_cmd_esc
	(int x);
/* put carriage return & linefeed */
void show_crlf
	(void);
/* ask user for verification of choice */
int ask_verify
	(void);
/* prompt user to input a double */
double ask_dbl
	(char *prompt);
/* prompt user to input a long integer */
long int ask_lint
	(char *prompt);
/* prompt user to input an integer (short) */
int ask_int
	(char *prompt);
/* prompt user to input an unsigned char */
unsigned char ask_byte
	(char *prompt);
/* ask for byte string in hex format, returns number of bytes read */
unsigned char ask_hex_string (
  	char *prompt,
	unsigned char *h,
	unsigned char maxchar);
/* ask for byte string in char format, returns number of bytes read */
int ask_char_string
   (char *prompt,
	char *h);
/* prompt user to pick among a finite number of choices */
unsigned char PickFromMenu
	(char *prompt,
   char *MenuItems[],
   int nopts);

/* functions to get time */
void GPS_time_from_PC
	(double *time);

/* BORLAND window functions */
void switch_window
	(int window_id);
void clr_cmd_window
	(int mode);
void start_menu_window
	(void);
void end_menu_window
	(void);
void new_cmd_window
	(void);
int which_window
	(void);
void initialize_screen
	(void);
void reset_screen
	(void);

/* file storage control */
void open_file_storage
	(FILE **stream, char *filename);
void close_file_storage
	(FILE **stream, char *filename);


